create or replace PROCEDURE IMPORTA_GRUPOPRATO (
   P_NRIMPGRUPOPRATO IN NUMBER,
   P_NRORG IN NUMBER DEFAULT 1,
   P_RETORNO OUT NUMBER
) IS
   V_RETORNO NUMBER;
   V_EXISTEPADGRUPO NUMBER;
   V_INSERE_AGRUP VARCHAR2(6);
   V_INSERE_GRUPO VARCHAR2(6);
   V_INSERE_GRUPOPRATOSERV VARCHAR2(6);
   V_STATUS VARCHAR2(6);
   V_CONSISTE_GRUPO NUMBER;
   V_EXISTE_PRATO NUMBER;
   V_NRAGRUPGRPRAT NUMBER;
   V_NMAGRUPGRPRAT VARCHAR2(50);
   V_NRGRUPOPRATO NUMBER;
   V_NMGRUPOCADASTRADO VARCHAR2(50);
   V_NRGRUPOPRATOSERV NUMBER;
   V_NRITGRUPOPRATOSERV NUMBER;

   PROCEDURE INSERE_LISTA_ERRO IS
   BEGIN
      IF V_RETORNO IS NULL THEN
         NOVO_CODIGO('LOG_IMP_GRUPOPRATO',V_RETORNO);
      END IF;
   END INSERE_LISTA_ERRO;

BEGIN
   SELECT COUNT(*) 
     INTO V_EXISTEPADGRUPO
     FROM PADGRUPOPRATO;
   
   FOR C_PLANILHA IN (
      SELECT I.NRIMPGRUPOPRATO, I.NRINDICE, I.CDFILIAL, I.CDSERVFILI, 
             I.CDAGRUPGRPRAT, I.NMAGRUPGRPRAT, AG.NRAGRUPGRPRAT AS NRAGRUPGRPRAT, AG.NMAGRUPGRPRAT AS NMAGRUPCADASTRADO, 
             I.CDGRUPOPRATO, PD.CDPADGRUPOPRATO, I.NMGRUPOPRATO, G.NRGRUPOPRATO AS NRGRUPOPRATOCADASTRADO, G.NMGRUPOPRATO AS NMGRUPOCADASTRADO, 
             I.CDFILAUXPRAT, I.CDPRATO, I.IDTIPORESTRICAO
        FROM IMP_GRUPOPRATO I --LEFT JOIN PRATO P ON (I.CDPRATO = P.CDPRATO) AND (I.CDFILAUXPRAT = P.CDFILAUXPRAT)
                              LEFT JOIN AGRUPGRPRAT AG ON AG.CDAGRUPGRPRAT = I.CDAGRUPGRPRAT AND AG.IDTIPORESTRICAO = I.IDTIPORESTRICAO
                              LEFT JOIN GRUPOPRATO G ON G.CDFILIAL = I.CDFILIAL AND G.CDGRUPOPRATO = I.CDGRUPOPRATO AND G.IDTIPORESTRICAO = I.IDTIPORESTRICAO
                              LEFT JOIN PADGRUPOPRATO PD ON PD.CDPADGRUPOPRATO = I.CDGRUPOPRATO AND PD.IDTIPORESTRICAO = I.IDTIPORESTRICAO
       WHERE I.NRIMPGRUPOPRATO = P_NRIMPGRUPOPRATO
       ORDER BY I.NRINDICE
   )LOOP
      V_INSERE_AGRUP := '';
      V_INSERE_GRUPO := '';
      V_INSERE_GRUPOPRATOSERV := '';
      V_STATUS := 'OK';
      
      BEGIN 
         SELECT COUNT(1)
          INTO V_EXISTE_PRATO
          FROM PRATO 
         WHERE CDFILAUXPRAT = C_PLANILHA.CDFILAUXPRAT AND
               CDPRATO = C_PLANILHA.CDPRATO;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
         V_EXISTE_PRATO := 0;
      END;
            
          
      
      
      /*SE O PRATO NO EXISTE OU PERTENCE A OUTRA FILIAL (CDFILAUXPRAT NULO) RETORNA ERRO*/
      IF V_EXISTE_PRATO = 0 THEN
         INSERE_LISTA_ERRO;
         INSERT INTO LOG_IMP_GRUPOPRATO(DSLOGIMPGRUPOPRATO,NRLOGIMPGRUPOPRATO)VALUES('Linha: '||C_PLANILHA.NRINDICE||' - O prato '||C_PLANILHA.CDPRATO||' no existe ou no pertence a unidade informada.',V_RETORNO);
         V_STATUS := 'ERRO';
      END IF;
      /*SE EXISTE PADRAO DE GRUPO DE PRATO MAS O GRUPO NAO ESTA CADASTRADO NO PADRAO, RETORNA ERRO PARA CADASTRAR UM NOVO PADRAO*/
      IF V_EXISTEPADGRUPO > 0 AND C_PLANILHA.CDPADGRUPOPRATO IS NULL THEN
         INSERE_LISTA_ERRO;
         INSERT INTO LOG_IMP_GRUPOPRATO(DSLOGIMPGRUPOPRATO,NRLOGIMPGRUPOPRATO)VALUES('Linha: '||C_PLANILHA.NRINDICE||' - O grupo de prato '||C_PLANILHA.CDGRUPOPRATO||' no possui padro de grupo de prato cadastrado.',V_RETORNO);
         V_INSERE_GRUPO := 'ERRO';
         V_STATUS := 'ERRO';
      END IF;
      /*VALIDACOES QUE DEMANDAM SELECT NOS GRUPOS AGRUPAMENTOS E AGRUPAMENTOS POR SERVICO*/
      
      /*VALIDACAO DO AGRUPAMENTO SE ESTA PREENCHIDO, VERIFICA SE JA EXISTE E COMPARA COM O NOME DO QUE EXISTE*/
      IF (C_PLANILHA.CDAGRUPGRPRAT IS NOT NULL) THEN
         IF (C_PLANILHA.NRAGRUPGRPRAT IS NOT NULL) THEN
            /*SE O AGRUPAMENTO EXISTE COM OUTRO NOME RETORNA ERRO*/
            IF (LTRIM(RTRIM(C_PLANILHA.NMAGRUPGRPRAT)) <> LTRIM(RTRIM(C_PLANILHA.NMAGRUPGRPRAT))) THEN
               INSERE_LISTA_ERRO;
               INSERT INTO LOG_IMP_GRUPOPRATO(DSLOGIMPGRUPOPRATO,NRLOGIMPGRUPOPRATO)VALUES('Linha: '||C_PLANILHA.NRINDICE||' - O agrupamento '||C_PLANILHA.NMAGRUPGRPRAT||' j existe com outro nome: '||C_PLANILHA.NMAGRUPCADASTRADO ,V_RETORNO);
               V_INSERE_AGRUP := 'ERRO';
               V_STATUS := 'ERRO';
            ELSE
               V_NRAGRUPGRPRAT := C_PLANILHA.NRAGRUPGRPRAT;
               V_INSERE_AGRUP := 'UPDATE';
            END IF;
         ELSE
            BEGIN
               SELECT MAX(NRAGRUPGRPRAT), MAX(NMAGRUPGRPRAT)
                 INTO V_NRAGRUPGRPRAT, V_NMAGRUPGRPRAT
                 FROM AGRUPGRPRAT WHERE CDAGRUPGRPRAT = C_PLANILHA.CDAGRUPGRPRAT AND IDTIPORESTRICAO = C_PLANILHA.IDTIPORESTRICAO;
            EXCEPTION 
            WHEN NO_DATA_FOUND THEN
               V_NRAGRUPGRPRAT := NULL;
               V_NMAGRUPGRPRAT := NULL;
            END;   
            IF V_NRAGRUPGRPRAT IS NULL THEN
               IF C_PLANILHA.NMAGRUPGRPRAT IS NULL THEN
                  INSERE_LISTA_ERRO;
                  INSERT INTO LOG_IMP_GRUPOPRATO(DSLOGIMPGRUPOPRATO,NRLOGIMPGRUPOPRATO)VALUES('Linha: '||C_PLANILHA.NRINDICE||' - O agrupamento  novo, o nome deve ser informado.' ,V_RETORNO);                  
                  V_INSERE_AGRUP := 'ERRO';
                  V_STATUS := 'ERRO';
               ELSE
                  V_INSERE_AGRUP := 'INSERT';
               END IF;
            ELSE
               IF (LTRIM(RTRIM(C_PLANILHA.NMAGRUPGRPRAT)) <> LTRIM(RTRIM(V_NMAGRUPGRPRAT))) THEN
                  INSERE_LISTA_ERRO;
                  INSERT INTO LOG_IMP_GRUPOPRATO(DSLOGIMPGRUPOPRATO,NRLOGIMPGRUPOPRATO)VALUES('Linha: '||C_PLANILHA.NRINDICE||' - O agrupamento '||C_PLANILHA.NMAGRUPGRPRAT||' j existe com outro nome: '||C_PLANILHA.NMAGRUPCADASTRADO ,V_RETORNO);
                  V_INSERE_AGRUP := 'ERRO';
                  V_STATUS := 'ERRO';
               ELSE
                  V_INSERE_AGRUP := 'UPDATE';
               END IF;
            END IF;
         END IF;
      END IF;
      
      /*VALIDA SE EXISTE GRUPO POR FILIAL, SERVICO E O PRATO, SE NAO EXISTE VAI TENTAR CADASTRAR TODOS*/
      IF C_PLANILHA.NRGRUPOPRATOCADASTRADO IS NOT NULL THEN
         /*SE O GRUPO DE PRATO JA ESTA CADASTRADO VALIDA SE TEM O MESMO NOME*/
         IF (LTRIM(RTRIM(C_PLANILHA.NMGRUPOPRATO)) <> LTRIM(RTRIM(C_PLANILHA.NMGRUPOCADASTRADO))) THEN
            INSERE_LISTA_ERRO;
            INSERT INTO LOG_IMP_GRUPOPRATO(DSLOGIMPGRUPOPRATO,NRLOGIMPGRUPOPRATO)VALUES('Linha: '||C_PLANILHA.NRINDICE||' - O grupo de prato '||C_PLANILHA.NMGRUPOPRATO||' j existe com outro nome: '||C_PLANILHA.NMGRUPOCADASTRADO ,V_RETORNO);
            V_INSERE_GRUPO := 'ERRO';
            V_STATUS := 'ERRO';
         ELSE
            V_INSERE_GRUPO := 'UPDATE';
         END IF;
      END IF;
     
      BEGIN
         SELECT G.NRGRUPOPRATO, G.NMGRUPOPRATO, GS.NRGRUPOPRATOSERV, IT.NRITGRUPOPRATOSERV
           INTO V_NRGRUPOPRATO, V_NMGRUPOCADASTRADO, V_NRGRUPOPRATOSERV, V_NRITGRUPOPRATOSERV
           FROM GRUPOPRATO G LEFT JOIN GRUPOPRATOSERV GS ON G.NRGRUPOPRATO = GS.NRGRUPOPRATO AND GS.CDSERVFILI = C_PLANILHA.CDSERVFILI
                             LEFT JOIN ITGRUPOPRATOSERV IT ON IT.NRGRUPOPRATOSERV = GS.NRGRUPOPRATOSERV AND
                                                              IT.CDFILAUXPRAT = C_PLANILHA.CDFILAUXPRAT AND
                                                              IT.CDPRATO = C_PLANILHA.CDPRATO
           WHERE G.CDGRUPOPRATO = C_PLANILHA.CDGRUPOPRATO AND 
                 G.CDFILIAL = C_PLANILHA.CDFILIAL AND
                 G.IDTIPORESTRICAO = C_PLANILHA.IDTIPORESTRICAO;
      EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_NRGRUPOPRATO := NULL;
         V_NMGRUPOCADASTRADO := NULL;
         V_NRGRUPOPRATOSERV := NULL;
         V_NRITGRUPOPRATOSERV := NULL;
      END;
      
      /*SE O GRUPO DE PRATO JA ESTAVA CADASTRADO E POSSUI NOME DIFERENTE DA ERRO, SENAO UPDATE*/      
      IF (V_NRGRUPOPRATO IS NOT NULL) THEN
         IF (LTRIM(RTRIM(C_PLANILHA.NMGRUPOPRATO)) <> LTRIM(RTRIM(V_NMGRUPOCADASTRADO))) THEN
            INSERE_LISTA_ERRO;
            INSERT INTO LOG_IMP_GRUPOPRATO(DSLOGIMPGRUPOPRATO,NRLOGIMPGRUPOPRATO)VALUES('Linha: '||C_PLANILHA.NRINDICE||' - O grupo de prato '||C_PLANILHA.NMGRUPOPRATO||' j existe com outro nome: '||V_NMGRUPOCADASTRADO ,V_RETORNO);
            V_INSERE_GRUPO := 'ERRO';
            V_STATUS := 'ERRO';
         ELSE
            V_INSERE_GRUPO := 'UPDATE';
         END IF;
      ELSE
         IF C_PLANILHA.NMGRUPOPRATO IS NULL THEN
            INSERE_LISTA_ERRO;
            INSERT INTO LOG_IMP_GRUPOPRATO(DSLOGIMPGRUPOPRATO,NRLOGIMPGRUPOPRATO)VALUES('Linha: '||C_PLANILHA.NRINDICE||' - O grupo de prato  novo, o nome deve ser informado.' ,V_RETORNO);                  
            V_INSERE_GRUPO := 'ERRO';
            V_STATUS := 'ERRO';
         ELSE
            V_INSERE_GRUPO := 'INSERT';
         END IF;
      END IF;
      
      /*SE O PRATO JA ESTA CADASTRADO PARA O GRUPO ENTAO RETORNA ERRO*/
      IF V_NRITGRUPOPRATOSERV IS NOT NULL THEN
         INSERE_LISTA_ERRO;
         INSERT INTO LOG_IMP_GRUPOPRATO(DSLOGIMPGRUPOPRATO,NRLOGIMPGRUPOPRATO)VALUES('Linha: '||C_PLANILHA.NRINDICE||' - Prato: '||C_PLANILHA.CDPRATO||' j vinculado ao grupo.',V_RETORNO);
         V_STATUS := 'ERRO';
         CONTINUE;
      END IF;
      /*SE O PRATO NAO ESTA CADASTRADO MAS EXISTE O GRUPO DE PRATO POR SERVICO ENTAO INSERE O PRATO*/
      IF (V_NRITGRUPOPRATOSERV IS NULL) AND (V_NRGRUPOPRATOSERV IS NOT NULL) THEN
         V_INSERE_GRUPOPRATOSERV := 'UPDATE';
      END IF;
      
      /*SE O PRATO NAO ESTA CADASTRADO, NAO EXISTE O GRUPO DE PRATO POR SERVICO MAS EXISTE O GRUPO DE PRATO ENTAO INSERE O GRUPO POR SERVICO E O PRATO*/
      IF (V_NRITGRUPOPRATOSERV IS NULL) AND (V_NRGRUPOPRATOSERV IS NULL) AND (V_NRGRUPOPRATO IS NOT NULL) THEN
         V_INSERE_GRUPOPRATOSERV := 'INSERT';
      END IF;
      
      /*SE O GRUPO DE PRATO NAO EXISTE E O PADRAO DE GRUPO DE PRATO FOI VALIDADO, INSERE O GRUPO, O GRUPO POR SERVICO E O PRATO*/
      IF (V_NRGRUPOPRATO IS NULL) AND (V_INSERE_GRUPO <> 'ERRO') THEN
         V_INSERE_GRUPOPRATOSERV := 'INSERT';
         V_INSERE_GRUPO := 'INSERT';
      END IF;
      
      /*VALIDA SE O PRATO ESTA ASSOCIADO AO MESMO SERVICO EM MAIS DE UM GRUPO DE PRATO*/
      IF (V_NRGRUPOPRATO IS NOT NULL) THEN
         BEGIN
            SELECT COUNT(*)
              INTO V_CONSISTE_GRUPO
              FROM GRUPOPRATOSERV GS INNER JOIN GRUPOPRATO G ON G.NRGRUPOPRATO = GS.NRGRUPOPRATO AND 
                                                                G.CDFILIAL = C_PLANILHA.CDFILIAL  AND
                                                                G.IDTIPORESTRICAO = C_PLANILHA.IDTIPORESTRICAO
                                     INNER JOIN ITGRUPOPRATOSERV IT ON IT.NRGRUPOPRATOSERV = GS.NRGRUPOPRATOSERV AND 
                                                                      GS.CDSERVFILI = C_PLANILHA.CDSERVFILI AND 
                                                                      IT.CDFILAUXPRAT = C_PLANILHA.CDFILAUXPRAT AND 
                                                                      IT.CDPRATO = C_PLANILHA.CDPRATO AND
                                                                      GS.NRGRUPOPRATO <> V_NRGRUPOPRATO;
         EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_CONSISTE_GRUPO := 0;
         END;
      
         IF V_CONSISTE_GRUPO > 0 THEN
            INSERE_LISTA_ERRO;
            INSERT INTO LOG_IMP_GRUPOPRATO(DSLOGIMPGRUPOPRATO,NRLOGIMPGRUPOPRATO)VALUES('Linha: '||C_PLANILHA.NRINDICE||' - Prato: '||C_PLANILHA.CDPRATO||' j vinculado ao mesmo servio em outro grupo de prato.',V_RETORNO);
            V_STATUS := 'ERRO';
            CONTINUE;
         END IF;
      END IF;
      
      /*VALIDA SE O REGISTRO PODE SER INSERIDO NAS TABELAS*/
      IF V_STATUS = 'OK' THEN
         /*VERIFICA SE VAI INSERIR UM NOVO AGRUPAMENTO OU SO ASSOCIAR O GRUPO AO AGRUPAMENTO INFORMADO*/
         IF (V_INSERE_AGRUP = 'INSERT') AND (C_PLANILHA.CDAGRUPGRPRAT IS NOT NULL) THEN
            NOVO_CODIGO('AGRUPGRPRAT',V_NRAGRUPGRPRAT);
            INSERT INTO AGRUPGRPRAT(NRAGRUPGRPRAT, CDAGRUPGRPRAT,NMAGRUPGRPRAT, NRORG, IDTIPORESTRICAO) 
               VALUES (V_NRAGRUPGRPRAT, C_PLANILHA.CDAGRUPGRPRAT, C_PLANILHA.NMAGRUPGRPRAT, P_NRORG, C_PLANILHA.IDTIPORESTRICAO);
         END IF;
         /*VERIFICA SE DEVE INSERIR O GRUPO DE PRATO PARA A FILIAL*/
         IF V_INSERE_GRUPO = 'INSERT' THEN
            NOVO_CODIGO('GRUPOPRATO',V_NRGRUPOPRATO);
            INSERT INTO GRUPOPRATO(NRGRUPOPRATO, CDFILIAL, CDGRUPOPRATO, NMGRUPOPRATO, NRORG, IDTIPORESTRICAO) 
               VALUES (V_NRGRUPOPRATO, C_PLANILHA.CDFILIAL, C_PLANILHA.CDGRUPOPRATO, C_PLANILHA.NMGRUPOPRATO, P_NRORG, C_PLANILHA.IDTIPORESTRICAO);
         END IF;
         /*VERIFICA SE DEVE INSERIR O GRUPO DE PRATO PARA O SERVICO*/
         IF V_INSERE_GRUPOPRATOSERV = 'INSERT' THEN
            NOVO_CODIGO('GRUPOPRATOSERV',V_NRGRUPOPRATOSERV);
            INSERT INTO GRUPOPRATOSERV (NRGRUPOPRATOSERV, NRGRUPOPRATO, NRAGRUPGRPRAT, CDSERVFILI, NRORG) 
               VALUES (V_NRGRUPOPRATOSERV, V_NRGRUPOPRATO, NVL(V_NRAGRUPGRPRAT,C_PLANILHA.NRAGRUPGRPRAT),C_PLANILHA.CDSERVFILI, P_NRORG);
         END IF;
         
         /*INSERE O ITEM DO PRATO*/
         NOVO_CODIGO('ITGRUPOPRATOSERV', V_NRITGRUPOPRATOSERV);
         INSERT INTO ITGRUPOPRATOSERV (NRITGRUPOPRATOSERV, NRGRUPOPRATOSERV, CDFILAUXPRAT, CDPRATO, NRORG)
            VALUES (V_NRITGRUPOPRATOSERV, V_NRGRUPOPRATOSERV, C_PLANILHA.CDFILAUXPRAT, C_PLANILHA.CDPRATO, P_NRORG);
      END IF;
      
   END LOOP;
   COMMIT;
   P_RETORNO := V_RETORNO;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('IMPORTA_GRUPOPRATO','6.25.000'); END;
/